#version 330                                                                        
                                                                                    
layout(points) in;      
layout(points) out;                                                            
//layout(triangle_strip) out;                                                         
layout(max_vertices = 30) out;                                                       
                              
in vec3 Position0[];
in vec3 Velocity0[];
in float Age0[];							  
in float Type0[];							  
							                                                        
//uniform mat4 gVP;                                                                   
//uniform vec3 gCameraPos;          
uniform float deltaTime;             
uniform sampler1D randomTex;  
uniform vec3 newPosition;                                      
                                                                                    
out vec3 Position1;
out vec3 Velocity1;
out float Age1;
out float Type1;
//out vec2 TexCoord;                                                                  
                                                                                    
void main()                                                                         
{                                                                                   
   // vec3 Pos = gl_in[0].gl_Position.xyz;                                            
   // vec3 toCamera = normalize(gCameraPos - Pos);                                    
   // vec3 up = vec3(0.0, 1.0, 0.0);                                                  
   // vec3 right = cross(toCamera, up);                                               
   float deltaSec = deltaTime/1000.0;

   if (Type0[0] < 0.01) {
   		//Position1 = Position0[0] + Velocity0[0];   
		Position1 = newPosition; 
		Velocity1 = Velocity0[0];       
		Age1 = Age0[0] + deltaTime;    
		Type1 = Type0[0];
		EmitVertex();       
		EndPrimitive();

		float modAge = mod(Age0[0], 100);
		if  ((modAge < 1) || (modAge > 50 && modAge < 52)) {
		//if (mod(modAge, 10) < 1) {
			float texInd = mod(Age0[0], 10000.0f) * 0.0001f;
  
			for (int i = 1; i < 15; i++) {
				//float texInd2 = float(i)/10.0;
				vec3 randDir = (texture(randomTex, texInd + i * 0.1f).xyz - vec3(0.5, 0.5, 0.5)) * 0.01;
				//Position1 = Position0[0] + randDir;//vec3(0.1, 0.0, 0.0);   
				Position1 = Position0[0] + randDir;   
				Velocity1 = randDir;       
				Age1 = 0; 
				Type1 = 1;     
				EmitVertex();       
				EndPrimitive();
			}
			/*
			randDir = (texture(randomTex, texInd+0.1).xyz - vec3(0.5, 0.5, 0.5)) / 100.0;
			Position1 = Position0[0] + randDir;   
			Velocity1 = randDir;
			EmitVertex();       
			EndPrimitive();

			randDir = (texture(randomTex, texInd+0.2).xyz - vec3(0.5, 0.5, 0.5)) / 100.0;
			Position1 = Position0[0] + randDir;   
			Velocity1 = randDir;
			EmitVertex();       
			EndPrimitive();
			*/
		}
   }

      if (Type0[0] > 0.99 && Age0[0] < 9000) {
		Position1 = Position0[0] + Velocity0[0]; // +  vec3(0.001, 0.0, 0.0);       
		Velocity1 = Velocity0[0] * 0.9999;       
		Age1 = Age0[0] + deltaTime;    
		Type1 = Type0[0];
		EmitVertex();       
		EndPrimitive();
	  }
								
  


	/*if (Age0[0] < 5000) {   
		for (int i = 0 ; i < 1 ; i++) {       
			
			//float texInd2 = float(i)/10.0;
			vec3 randDir = texture(randomTex, texInd).xyz - vec3(0.5, 0.5, 0.5);
			//Position1 = Position0[0] + randDir;//vec3(0.1, 0.0, 0.0);   
			Position1 = Position0[0] + Velocity0[0];   
			Velocity1 = Velocity0[0];       
			Age1 = 0; 
			Type1 = Type0[0];     
			EmitVertex();       
			EndPrimitive();  
		}
	}*/
	                                  
    /* //Pos -= (right * 0.5);                                                           
  //  gl_Position = gVP * vec4(Pos, 1.0);   
	Position1 = Position0[0] + vec3(0.001, 0.0, 0.0);      
	Velocity1 = Velocity0[0] + 0.0001;       
	Age1 = Age0[0] + deltaTime;                         
    //TexCoord = vec2(0.0, 0.0);                                                      
    EmitVertex();       
	EndPrimitive();                                                            
                                                                                    
//    Pos.y += 1.0;                                                                   
   // gl_Position = gVP * vec4(Pos, 1.0);       
	Position1 = Position0[0] +  vec3(-0.001, 0.0, 0.0);        
	Velocity1 = Velocity0[0] + 0.0001;         
	Age1 = Age0[0] + deltaTime;                            
   // TexCoord = vec2(0.0, 1.0);                                                      
    EmitVertex();  
	EndPrimitive();                                                                 
                                                                                    
//    Pos.y -= 1.0;                                                                   
//    Pos += right;                                                                   
   // gl_Position = gVP * vec4(Pos, 1.0);    
	Position1 = Position0[0] + vec3(0.0, -0.001, 0.0);    
	Velocity1 = Velocity0[0] + 0.0001;   
	Age1 = Age0[0] + deltaTime;                                        
    //TexCoord = vec2(1.0, 0.0);                                                      
    EmitVertex();  
	EndPrimitive();                                                                 
                                                                                    
 //   Pos.y += 1.0;                                                                   
    //gl_Position = gVP * vec4(Pos, 1.0);    
	Position1 = Position0[0] +  vec3(0.0, 0.001, 0.0);      
	Velocity1 = Velocity0[0] + 0.0001;       
	Age1 = Age0[0] + deltaTime;                                      
    //TexCoord = vec2(1.0, 1.0);                                                      
    EmitVertex();                                                                                                                                             
    EndPrimitive();      
	*/                                                           
}                                                                                   
